- Qt 6.9
- Qt 3D
- C++ Classes
- Qt3DRender (Deprecated)
- QPaintedTextureImage
- Qt 6.9.2 Reference Documentation

# Qt3DRender::QPaintedTextureImage Class

class Qt3DRender::QPaintedTextureImage

A QAbstractTextureImage that can be written through a QPainter. More...

Header: | `#include <QPaintedTextureImage>`
CMake: | `find_package(Qt6 REQUIRED COMPONENTS 3drender)` `target_link_libraries(mytarget PRIVATE Qt6::3drender)`
qmake: | `QT += 3drender`
Inherits: | Qt3DRender::QAbstractTextureImage
Status: | Deprecated

- List of all members, including inherited members

## Properties

- height : int
- size : QSize
- width : int

## Public Functions

int | height() const
QSize | size() const
void | update(const QRect &rect = QRect())
int | width() const

## Public Slots

void | setHeight(int h)
void | setSize(QSize size)
void | setWidth(int w)

## Signals

void | heightChanged(int w)
void | sizeChanged(QSize size)
void | widthChanged(int w)

## Protected Functions

virtual void | paint(QPainter *painter) = 0

## Detailed Description

A QPaintedTextureImage provides a way to specify a texture image (and thus an OpenGL texture) through a QPainter. The width and height of the texture image can be specified through the width and height or size properties.

A QPaintedTextureImage must be subclassed and the virtual paint() function implemented. Each time update() is called on the QPaintedTextureImage, the paint() function is invoked and the resulting image is uploaded.

The QPaintedTextureImage must be attached to some QAbstractTexture.

## Property Documentation

### height : int

This property holds the height of the texture image. The height must be greater than or equal to 1.

Access functions:

int | height() const
void | setHeight(int h)

Notifier signal:

void | heightChanged(int w)

### size : QSize

This property holds the size of the texture image.

Access functions:

QSize | size() const
void | setSize(QSize size)

Notifier signal:

void | sizeChanged(QSize size)

See also height and width.

### width : int

This property holds the width of the texture image. The width must be greater than or equal to 1.

Access functions:

int | width() const
void | setWidth(int w)

Notifier signal:

void | widthChanged(int w)

## Member Function Documentation

### `[pure virtual protected]` void QPaintedTextureImage::paint(QPainter *painter)

Paints the texture image with the specified QPainter object painter.

QPainter considers the top-left corner of an image as its origin, while OpenGL considers the bottom-left corner of a texture as its origin. An easy way to account for this difference is to set a custom viewport on the painter before doing any other painting:

     painter->setViewport(0, height(), width(), -height());
     ...

### `[slot]` void QPaintedTextureImage::setHeight(int h)

Sets the height (h) of the texture image. Triggers an update, if the size changes.

Note: Setter function for property height.

See also height().

### `[slot]` void QPaintedTextureImage::setSize(QSize size)

Sets the width and height of the texture image. Triggers an update, if the size changes.

Note: Setter function for property size.

See also size().

### `[slot]` void QPaintedTextureImage::setWidth(int w)

Sets the width (w) of the texture image. Triggers an update, if the size changes.

Note: Setter function for property width.

See also width().

### void QPaintedTextureImage::update(const QRect &rect = QRect())

Immediately triggers the painted texture's paint() function, which in turn uploads the new image to the GPU. If you are making multiple changes to a painted texture, consider waiting until all changes are complete before calling update, in order to minimize the number of repaints required.

Parameter rect is currently unused.